diff --git a/output.py b/output.py
old mode 100644
new mode 100755
index 502aa4b..3416459
--- a/output.py
+++ b/output.py
@@ -38,7 +38,7 @@ from yum import logginglevels, _
 from yum.rpmtrans import RPMBaseCallback
 from yum.packageSack import packagesNewestByNameArch
 
-from textwrap import fill
+from yum.i18n import utf8_width, utf8_width_fill, utf8_text_fill
 
 def _term_width():
     """ Simple terminal width, limit to 20 chars. and make 0 == 80. """
@@ -75,42 +75,7 @@ class YumTerm:
     __enabled = True
 
     if hasattr(urlgrabber.progress, 'terminal_width_cached'):
-        columns = property(lambda self: _term_width())
-    else:
-        columns = 80
-    lines   = 24
-    # Output modes:
-    MODE = {
-        'bold' : '',
-        'blink' : '',
-        'dim' : '',
-        'reverse' : '',
-        'underline' : '',
-        'normal' : ''
-        }
-
-    # Colours
-    FG_COLOR = {
-        'black' : '',
-        'blue' : '',
-        'green' : '',
-        'cyan' : '',
-        'red' : '',
-        'magenta' : '',
-        'yellow' : '',
-        'white' : ''
-        }
-
-    BG_COLOR = {
-        'black' : '',
-        'blue' : '',
-        'green' : '',
-        'cyan' : '',
-        'red' : '',
-        'magenta' : '',
-        'yellow' : '',
-        'white' : ''
-        }
+        __auto_columns = property(lambda self: _term_width())
 
     __cap_names = {
         'underline' : 'smul',
@@ -138,8 +103,90 @@ class YumTerm:
         'cyan' : 6,
         'white' : 7
         }
+    __ansi_forced_MODE = {
+        'bold' : '\x1b[1m',
+        'blink' : '\x1b[5m',
+        'dim' : '',
+        'reverse' : '\x1b[7m',
+        'underline' : '\x1b[4m',
+        'normal' : '\x1b(B\x1b[m'
+        }
+    __ansi_forced_FG_COLOR = {
+        'black' : '\x1b[30m',
+        'red' : '\x1b[31m',
+        'green' : '\x1b[32m',
+        'yellow' : '\x1b[33m',
+        'blue' : '\x1b[34m',
+        'magenta' : '\x1b[35m',
+        'cyan' : '\x1b[36m',
+        'white' : '\x1b[37m'
+        }
+    __ansi_forced_BG_COLOR = {
+        'black' : '\x1b[40m',
+        'red' : '\x1b[41m',
+        'green' : '\x1b[42m',
+        'yellow' : '\x1b[43m',
+        'blue' : '\x1b[44m',
+        'magenta' : '\x1b[45m',
+        'cyan' : '\x1b[46m',
+        'white' : '\x1b[47m'
+        }
+
+    def __forced_init(self):
+        self.MODE = self.__ansi_forced_MODE
+        self.FG_COLOR = self.__ansi_forced_FG_COLOR
+        self.BG_COLOR = self.__ansi_forced_BG_COLOR
+
+    def reinit(self, term_stream=None, color='auto'):
+        if color == 'never':
+            self.__enabled = False
+            return
+
+        self.__enabled = True
+        if hasattr(urlgrabber.progress, 'terminal_width_cached'):
+            self.columns = self.__auto_columns
+        else:
+            self.columns = 80
+        self.lines = 24
+
+        if color == 'always':
+            self.__forced_init()
+            return
+        assert color == 'auto'
+
+        # Output modes:
+        self.MODE = {
+            'bold' : '',
+            'blink' : '',
+            'dim' : '',
+            'reverse' : '',
+            'underline' : '',
+            'normal' : ''
+            }
+
+        # Colours
+        self.FG_COLOR = {
+            'black' : '',
+            'blue' : '',
+            'green' : '',
+            'cyan' : '',
+            'red' : '',
+            'magenta' : '',
+            'yellow' : '',
+            'white' : ''
+            }
+
+        self.BG_COLOR = {
+            'black' : '',
+            'blue' : '',
+            'green' : '',
+            'cyan' : '',
+            'red' : '',
+            'magenta' : '',
+            'yellow' : '',
+            'white' : ''
+            }
 
-    def __init__(self, term_stream=None):
         # Curses isn't available on all platforms
         try:
             import curses
@@ -165,7 +212,7 @@ class YumTerm:
 
         if not hasattr(urlgrabber.progress, 'terminal_width_cached'):
             self.columns = curses.tigetnum('cols')
-        self.lines   = curses.tigetnum('lines')
+        self.lines = curses.tigetnum('lines')
         
         # Look up string capabilities.
         for cap_name in self.MODE:
@@ -192,6 +239,9 @@ class YumTerm:
             for (color, val) in self.__ansi_colors.items():
                 self.BG_COLOR[color] = curses.tparm(set_bg_ansi, val) or ''
 
+    def __init__(self, term_stream=None, color='auto'):
+        self.reinit(term_stream, color)
+
     def _tigetstr(self, cap_name):
         # String capabilities can include "delays" of the form "$<2>".
         # For any modern terminal, we should be able to just ignore
@@ -199,7 +249,7 @@ class YumTerm:
         cap = self._ctigetstr(cap_name) or ''
         return re.sub(r'\$<\d+>[/*]?', '', cap)
 
-    def sub(self, haystack, beg, end, needles, escape=None):
+    def sub(self, haystack, beg, end, needles, escape=None, ignore_case=False):
         if not self.__enabled:
             return haystack
 
@@ -208,7 +258,10 @@ class YumTerm:
 
         render = lambda match: beg + match.group() + end
         for needle in needles:
-            haystack = re.sub(escape(needle), render, haystack)
+            pat = escape(needle)
+            if ignore_case:
+                pat = re.template(pat, re.I)
+            haystack = re.sub(pat, render, haystack)
         return haystack
     def sub_norm(self, haystack, beg, needles, **kwds):
         return self.sub(haystack, beg, self.MODE['normal'], needles, **kwds)
@@ -217,7 +270,7 @@ class YumTerm:
         return self.sub_norm(haystack, self.MODE[mode], needles, **kwds)
 
     def sub_bold(self, haystack, needles, **kwds):
-        return self.sub_mode(haystack, 'bold', needles)
+        return self.sub_mode(haystack, 'bold', needles, **kwds)
     
     def sub_fg(self, haystack, color, needles, **kwds):
         return self.sub_norm(haystack, self.FG_COLOR[color], needles, **kwds)
@@ -263,14 +316,39 @@ class YumOutput:
         progressbar(current, total, name)
 
     def _highlight(self, highlight):
-        if highlight:
+        hibeg = ''
+        hiend = ''
+        if not highlight:
+            pass
+        elif not isinstance(highlight, basestring) or highlight == 'bold':
             hibeg = self.term.MODE['bold']
-            hiend = self.term.MODE['normal']
+        elif highlight == 'normal':
+            pass # Minor opt.
         else:
-            hibeg = ''
-            hiend = ''
+            # Turn a string into a specific output: colour, bold, etc.
+            for high in highlight.replace(',', ' ').split():
+                if False: pass
+                elif high == 'normal':
+                    hibeg = ''
+                elif high in self.term.MODE:
+                    hibeg += self.term.MODE[high]
+                elif high in self.term.FG_COLOR:
+                    hibeg += self.term.FG_COLOR[high]
+                elif (high.startswith('fg:') and
+                      high[3:] in self.term.FG_COLOR):
+                    hibeg += self.term.FG_COLOR[high[3:]]
+                elif (high.startswith('bg:') and
+                      high[3:] in self.term.BG_COLOR):
+                    hibeg += self.term.BG_COLOR[high[3:]]
+
+        if hibeg:
+            hiend = self.term.MODE['normal']
         return (hibeg, hiend)
 
+    def _sub_highlight(self, haystack, highlight, needles, **kwds):
+        hibeg, hiend = self._highlight(highlight)
+        return self.term.sub(haystack, hibeg, hiend, needles, **kwds)
+
     @staticmethod
     def _calc_columns_spaces_helps(current, data_tups, left):
         """ Spaces left on the current field will help how many pkgs? """
@@ -299,7 +377,7 @@ class YumOutput:
         if columns is None:
             columns = [1] * cols
 
-        total_width -= (sum(columns) + (cols - 1) + len(indent))
+        total_width -= (sum(columns) + (cols - 1) + utf8_width(indent))
         while total_width > 0:
             # Find which field all the spaces left will help best
             helps = 0
@@ -339,28 +417,45 @@ class YumOutput:
             return (u"-", -width)
         return (u"", width)
 
+    def _col_data(self, col_data):
+        assert len(col_data) == 2 or len(col_data) == 3
+        if len(col_data) == 2:
+            (val, width) = col_data
+            hibeg = hiend = ''
+        if len(col_data) == 3:
+            (val, width, highlight) = col_data
+            (hibeg, hiend) = self._highlight(highlight)
+        return (val, width, hibeg, hiend)
+
     def fmtColumns(self, columns, msg=u'', end=u''):
         """ Return a string for columns of data, which can overflow."""
 
         total_width = len(msg)
         data = []
-        for (val, width) in columns[:-1]:
+        for col_data in columns[:-1]:
+            (val, width, hibeg, hiend) = self._col_data(col_data)
+
             if not width: # Don't count this column, invisible text
                 msg += u"%s"
                 data.append(val)
                 continue
 
             (align, width) = self._fmt_column_align_width(width)
-            if len(val) <= width:
-                msg += u"%%%s%ds " % (align, width)
+            if utf8_width(val) <= width:
+                msg += u"%s "
+                val = utf8_width_fill(val, width, left=(align == u'-'),
+                                      prefix=hibeg, suffix=hiend)
+                data.append(val)
             else:
-                msg += u"%s\n" + " " * (total_width + width + 1)
+                msg += u"%s%s%s\n" + " " * (total_width + width + 1)
+                data.extend([hibeg, val, hiend])
             total_width += width
             total_width += 1
-            data.append(val)
-        (val, width) = columns[-1]
+        (val, width, hibeg, hiend) = self._col_data(columns[-1])
         (align, width) = self._fmt_column_align_width(width)
-        msg += u"%%%s%ds%s" % (align, width, end)
+        val = utf8_width_fill(val, width, left=(align == u'-'),
+                              prefix=hibeg, suffix=hiend)
+        msg += u"%%s%s" % end
         data.append(val)
         return msg % tuple(data)
 
@@ -370,12 +465,10 @@ class YumOutput:
 
         if columns is None:
             columns = (-40, -22, -16) # Old default
-        (hibeg, hiend) = self._highlight(highlight)
         ver = pkg.printVer()
         na = '%s%s.%s' % (indent, pkg.name, pkg.arch)
-        columns = zip((na, ver, pkg.repoid), columns)
-        columns.insert(1, (hiend, 0))
-        columns.insert(0, (hibeg, 0))
+        hi_cols = [highlight, 'normal', 'normal']
+        columns = zip((na, ver, pkg.repoid), columns, hi_cols)
         print self.fmtColumns(columns)
 
     def simpleEnvraList(self, pkg, ui_overflow=False,
@@ -385,31 +478,30 @@ class YumOutput:
 
         if columns is None:
             columns = (-63, -16) # Old default
-        (hibeg, hiend) = self._highlight(highlight)
         envra = '%s%s' % (indent, str(pkg))
-        columns = zip((envra, pkg.repoid), columns)
-        columns.insert(1, (hiend, 0))
-        columns.insert(0, (hibeg, 0))
+        hi_cols = [highlight, 'normal', 'normal']
+        columns = zip((envra, pkg.repoid), columns, hi_cols)
         print self.fmtColumns(columns)
 
     def fmtKeyValFill(self, key, val):
         """ Return a key value pair in the common two column output format. """
         val = to_str(val)
-        keylen = len(key)
+        keylen = utf8_width(key)
         cols = self.term.columns
         nxt = ' ' * (keylen - 2) + ': '
-        ret = fill(val, width=cols,
-                   initial_indent=key, subsequent_indent=nxt)
+        ret = utf8_text_fill(val, width=cols,
+                             initial_indent=key, subsequent_indent=nxt)
         if ret.count("\n") > 1 and keylen > (cols / 3):
             # If it's big, redo it again with a smaller subsequent off
-            ret = fill(val, width=cols,
-                       initial_indent=key, subsequent_indent='     ...: ')
+            ret = utf8_text_fill(val, width=cols,
+                                 initial_indent=key,
+                                 subsequent_indent='     ...: ')
         return ret
     
     def fmtSection(self, name, fill='='):
         name = to_str(name)
         cols = self.term.columns - 2
-        name_len = len(name)
+        name_len = utf8_width(name)
         if name_len >= (cols - 4):
             beg = end = fill * 2
         else:
@@ -421,8 +513,7 @@ class YumOutput:
     def _enc(self, s):
         """Get the translated version from specspo and ensure that
         it's actually encoded in UTF-8."""
-        if type(s) == unicode:
-            s = s.encode("UTF-8")
+        s = to_utf8(s)
         if len(s) > 0:
             for d in self.i18ndomains:
                 t = gettext.dgettext(d, s)
@@ -433,24 +524,24 @@ class YumOutput:
 
     def infoOutput(self, pkg, highlight=False):
         (hibeg, hiend) = self._highlight(highlight)
-        print _("Name       : %s%s%s") % (hibeg, pkg.name, hiend)
-        print _("Arch       : %s") % pkg.arch
+        print _("Name       : %s%s%s") % (hibeg, to_unicode(pkg.name), hiend)
+        print _("Arch       : %s") % to_unicode(pkg.arch)
         if pkg.epoch != "0":
-            print _("Epoch      : %s") % pkg.epoch
-        print _("Version    : %s") % pkg.version
-        print _("Release    : %s") % pkg.release
+            print _("Epoch      : %s") % to_unicode(pkg.epoch)
+        print _("Version    : %s") % to_unicode(pkg.version)
+        print _("Release    : %s") % to_unicode(pkg.release)
         print _("Size       : %s") % self.format_number(float(pkg.size))
-        print _("Repo       : %s") % pkg.repoid
+        print _("Repo       : %s") % to_unicode(pkg.repoid)
         if self.verbose_logger.isEnabledFor(logginglevels.DEBUG_3):
-            print _("Committer  : %s") % pkg.committer
+            print _("Committer  : %s") % to_unicode(pkg.committer)
             print _("Committime : %s") % time.ctime(pkg.committime)
             print _("Buildtime  : %s") % time.ctime(pkg.buildtime)
             if hasattr(pkg, 'installtime'):
                 print _("Installtime: %s") % time.ctime(pkg.installtime)
         print self.fmtKeyValFill(_("Summary    : "), self._enc(pkg.summary))
         if pkg.url:
-            print _("URL        : %s") % pkg.url
-        print _("License    : %s") % pkg.license
+            print _("URL        : %s") % to_unicode(pkg.url)
+        print _("License    : %s") % to_unicode(pkg.license)
         print self.fmtKeyValFill(_("Description: "), self._enc(pkg.description))
         print ""
     
@@ -473,7 +564,7 @@ class YumOutput:
         print '%-35.35s [%.12s] %.10s %-20.20s' % (c_compact, c_repo, changetype, i_compact)
 
     def listPkgs(self, lst, description, outputType, highlight_na={},
-                 columns=None):
+                 columns=None, highlight_modes={}):
         """outputs based on whatever outputType is. Current options:
            'list' - simple pkg list
            'info' - similar to rpm -qi output
@@ -488,8 +579,15 @@ class YumOutput:
                 for pkg in sorted(lst):
                     key = (pkg.name, pkg.arch)
                     highlight = False
-                    if key in highlight_na and pkg.verLT(highlight_na[key]):
-                        highlight = True
+                    if False: pass
+                    elif key not in highlight_na:
+                        highlight = highlight_modes.get('not in', 'normal')
+                    elif pkg.verEQ(highlight_na[key]):
+                        highlight = highlight_modes.get('=', 'normal')
+                    elif pkg.verLT(highlight_na[key]):
+                        highlight = highlight_modes.get('>', 'bold')
+                    else:
+                        highlight = highlight_modes.get('<', 'normal')
 
                     if outputType == 'list':
                         self.simpleList(pkg, ui_overflow=True,
@@ -572,7 +670,7 @@ class YumOutput:
                 continue
             for (apkg, ipkg) in pkg_names2pkgs[item]:
                 pkg = ipkg or apkg
-                envra = len(str(pkg)) + len(indent)
+                envra = utf8_width(str(pkg)) + utf8_width(indent)
                 rid   = len(pkg.repoid)
                 for (d, v) in (('envra', envra), ('rid', rid)):
                     data[d].setdefault(v, 0)
@@ -590,8 +688,14 @@ class YumOutput:
                     continue
                 for (apkg, ipkg) in sorted(pkg_names2pkgs[item],
                                            key=lambda x: x[1] or x[0]):
+                    if ipkg and apkg:
+                        highlight = self.conf.color_list_installed_older
+                    elif apkg:
+                        highlight = self.conf.color_list_available_install
+                    else:
+                        highlight = False
                     self.simpleEnvraList(ipkg or apkg, ui_overflow=True,
-                                         indent=indent, highlight=ipkg and apkg,
+                                         indent=indent, highlight=highlight,
                                          columns=columns)
     
     def displayPkgsInGroups(self, group):
@@ -659,18 +763,15 @@ class YumOutput:
     
         thresh = 999
         depth = 0
+        max_depth = len(symbols) - 1
     
-        # we want numbers between 
-        while number > thresh:
+        # we want numbers between 0 and thresh, but don't exceed the length
+        # of our list.  In that event, the formatting will be screwed up,
+        # but it'll still show the right number.
+        while number > thresh and depth < max_depth:
             depth  = depth + 1
             number = number / step
     
-        # just in case someone needs more than 1000 yottabytes!
-        diff = depth - len(symbols) + 1
-        if diff > 0:
-            depth = depth - diff
-            number = number * thresh**depth
-    
         if type(number) == type(1) or type(number) == type(1L):
             format = '%i%s%s'
         elif number < 9.95:
@@ -680,13 +781,14 @@ class YumOutput:
         else:
             format = '%.0f%s%s'
     
-        return(format % (number, space, symbols[depth]))
+        return(format % (float(number or 0), space, symbols[depth]))
 
     @staticmethod
     def format_time(seconds, use_hours=0):
         return urlgrabber.progress.format_time(seconds, use_hours)
 
-    def matchcallback(self, po, values, matchfor=None, verbose=None):
+    def matchcallback(self, po, values, matchfor=None, verbose=None,
+                      highlight=None):
         """ Output search/provides type callback matches. po is the pkg object,
             values are the things in the po that we've matched.
             If matchfor is passed, all the strings in that list will be
@@ -699,7 +801,9 @@ class YumOutput:
             msg = '%s.%s : ' % (po.name, po.arch)
         msg = self.fmtKeyValFill(msg, self._enc(po.summary))
         if matchfor:
-            msg = self.term.sub_bold(msg, matchfor)
+            if highlight is None:
+                highlight = self.conf.color_search_match
+            msg = self._sub_highlight(msg, highlight, matchfor,ignore_case=True)
         
         print msg
 
@@ -708,6 +812,7 @@ class YumOutput:
         if not verbose:
             return
 
+        print _("Repo        : %s") % po.repoid
         print _('Matched from:')
         for item in yum.misc.unique(values):
             if po.name == item or po.summary == item:
@@ -732,7 +837,8 @@ class YumOutput:
                 key = _("Other       : ")
 
             if matchfor:
-                item = self.term.sub_bold(item, matchfor)
+                item = self._sub_highlight(item, highlight, matchfor,
+                                           ignore_case=True)
             if can_overflow:
                 print self.fmtKeyValFill(key, item)
             else:
@@ -778,38 +884,46 @@ class YumOutput:
         self.tsInfo.makelists()
         out = u""
         pkglist_lines = []
-        #  Tried to do this statically using:
-        #   http://fedorapeople.org/~james/yum/commands/length_distributions.py
-        # but it sucked for corner cases, so this is dynamic...
-
         data  = {'n' : {}, 'v' : {}, 'r' : {}}
         a_wid = 0 # Arch can't get "that big" ... so always use the max.
+
+        def _add_line(lines, data, a_wid, po, obsoletes=[]):
+            (n,a,e,v,r) = po.pkgtup
+            evr = po.printVer()
+            repoid = po.repoid
+            pkgsize = float(po.size)
+            size = self.format_number(pkgsize)
+
+            if a is None: # gpgkeys are weird
+                a = 'noarch'
+
+            lines.append((n, a, evr, repoid, size, obsoletes))
+            #  Create a dict of field_length => number of packages, for
+            # each field.
+            for (d, v) in (("n",len(n)), ("v",len(evr)), ("r",len(repoid))):
+                data[d].setdefault(v, 0)
+                data[d][v] += 1
+            if a_wid < len(a): # max() is only in 2.5.z
+                a_wid = len(a)
+            return a_wid
+
         for (action, pkglist) in [(_('Installing'), self.tsInfo.installed),
                             (_('Updating'), self.tsInfo.updated),
                             (_('Removing'), self.tsInfo.removed),
                             (_('Installing for dependencies'), self.tsInfo.depinstalled),
                             (_('Updating for dependencies'), self.tsInfo.depupdated),
-                            (_('Removing for dependencies'), self.tsInfo.depremoved),
-                            (_('Skipped (dependency problems)'), self.skipped_packages),]:
+                            (_('Removing for dependencies'), self.tsInfo.depremoved)]:
             lines = []
             for txmbr in pkglist:
-                (n,a,e,v,r) = txmbr.pkgtup
-                evr = txmbr.po.printVer()
-                repoid = txmbr.repoid
-                pkgsize = float(txmbr.po.size)
-                size = self.format_number(pkgsize)
-
-                if a is None: # gpgkeys are weird
-                    a = 'noarch'
-
-                lines.append((n, a, evr, repoid, size, txmbr.obsoletes))
-                #  Create a dict of field_length => number of packages, for
-                # each field.
-                for (d, v) in (("n",len(n)), ("v",len(evr)), ("r",len(repoid))):
-                    data[d].setdefault(v, 0)
-                    data[d][v] += 1
-                if a_wid < len(a): # max() is only in 2.5.z
-                    a_wid = len(a)
+                a_wid = _add_line(lines, data, a_wid, txmbr.po, txmbr.obsoletes)
+
+            pkglist_lines.append((action, lines))
+
+        for (action, pkglist) in [(_('Skipped (dependency problems)'),
+                                   self.skipped_packages),]:
+            lines = []
+            for po in pkglist:
+                a_wid = _add_line(lines, data, a_wid, po)
 
             pkglist_lines.append((action, lines))
 
@@ -1001,8 +1115,8 @@ Remove   %5.5s Package(s)
         ui_time = tl.add(' %9s' % self.format_time(dl_time))
         ui_end  = tl.add(' ' * 5)
         ui_bs   = tl.add(' %5sB/s' % self.format_number(remote_size / dl_time))
-        msg = "%-*.*s%s%s%s%s" % (tl.rest(), tl.rest(), _("Total"),
-                                  ui_bs, ui_size, ui_time, ui_end)
+        msg = "%s%s%s%s%s" % (utf8_width_fill(_("Total"), tl.rest(), tl.rest()),
+                              ui_bs, ui_size, ui_time, ui_end)
         self.verbose_logger.log(logginglevels.INFO_2, msg)
 
 
@@ -1099,7 +1213,7 @@ class YumCliRPMCallBack(RPMBaseCallback):
 
     def __init__(self):
         RPMBaseCallback.__init__(self)
-        self.lastmsg = None
+        self.lastmsg = to_unicode("")
         self.lastpackage = None # name of last package we looked at
         self.output = logging.getLogger("yum.verbose.cli").isEnabledFor(logginglevels.INFO_2)
         
@@ -1125,10 +1239,10 @@ class YumCliRPMCallBack(RPMBaseCallback):
             percent = (te_current*100L)/te_total
         
         if self.output and (sys.stdout.isatty() or te_current == te_total):
-            fmt = self._makefmt(percent, ts_current, ts_total, pkgname=pkgname)
-            # FIXME: Converting to utf8 here is a HACK ... but it's better
-            # to underflow than overflow, see the i18n-rpm-progress example
-            msg = fmt % (to_utf8(process), pkgname)
+            (fmt, wid1, wid2) = self._makefmt(percent, ts_current, ts_total,
+                                              pkgname=pkgname)
+            msg = fmt % (utf8_width_fill(process, wid1, wid1),
+                         utf8_width_fill(pkgname, wid2, wid2))
             if msg != self.lastmsg:
                 sys.stdout.write(to_unicode(msg))
                 sys.stdout.flush()
@@ -1153,7 +1267,7 @@ class YumCliRPMCallBack(RPMBaseCallback):
         if pkgname is None:
             pnl = 22
         else:
-            pnl = len(pkgname)
+            pnl = utf8_width(pkgname)
 
         overhead  = (2 * l) + 2 # Length of done, above
         overhead += 19          # Length of begining
@@ -1171,20 +1285,23 @@ class YumCliRPMCallBack(RPMBaseCallback):
         width = "%s.%s" % (marks, marks)
         fmt_bar = "[%-" + width + "s]"
         # pnl = str(28 + marks + 1)
-        full_pnl = "%%-%d.%ds" % (pnl + marks + 1, pnl + marks + 1)
-        half_pnl = "%%-%d.%ds" % (pnl, pnl)
+        full_pnl = pnl + marks + 1
 
         if progress and percent == 100: # Don't chop pkg name on 100%
-            fmt = "\r  %-15.15s: " + full_pnl + "   " + done
+            fmt = "\r  %s: %s   " + done
+            wid2 = full_pnl
         elif progress:
             bar = fmt_bar % (self.mark * int(marks * (percent / 100.0)), )
-            fmt = "\r  %-15.15s: " + half_pnl + " " + bar + " " + done
+            fmt = "\r  %s: %s " + bar + " " + done
+            wid2 = pnl
         elif percent == 100:
-            fmt = "  %-15.15s: " + full_pnl + "   " + done
+            fmt = "  %s: %s   " + done
+            wid2 = full_pnl
         else:
             bar = fmt_bar % (self.mark * marks, )
-            fmt = "  %-15.15s: " + half_pnl + " " + bar + " " + done
-        return fmt
+            fmt = "  %s: %s " + bar + " " + done
+            wid2 = pnl
+        return fmt, 15, wid2
 
 
 def progressbar(current, total, name=None):
@@ -1206,8 +1323,6 @@ def progressbar(current, total, name=None):
 
     if name is None and current == total:
         name = '-'
-    if name is not None: # FIXME: This is a hack without utf8_width()
-        width -= len(to_utf8(name)) - len(name)
 
     end = ' %d/%d' % (current, total)
     width -= len(end) + 1
@@ -1220,17 +1335,18 @@ def progressbar(current, total, name=None):
         hashbar = mark * int(width * percent)
         output = '\r[%-*s]%s' % (width, hashbar, end)
     elif current == total: # Don't chop name on 100%
-        output = '\r%-*.*s%s' % (width, width, name, end)
+        output = '\r%s%s' % (utf8_width_fill(name, width, width), end)
     else:
         width -= 4
         if width < 0:
             width = 0
         nwid = width / 2
-        if nwid > len(name):
-            nwid = len(name)
+        if nwid > utf8_width(name):
+            nwid = utf8_width(name)
         width -= nwid
         hashbar = mark * int(width * percent)
-        output = '\r%-*.*s: [%-*s]%s' % (nwid, nwid, name, width, hashbar, end)
+        output = '\r%s: [%-*s]%s' % (utf8_width_fill(name, nwid, nwid), width,
+                                     hashbar, end)
      
     if current <= total:
         sys.stdout.write(output)
diff --git a/rpmUtils/updates.py b/rpmUtils/updates.py
index f348ae9..16f733b 100644
--- a/rpmUtils/updates.py
+++ b/rpmUtils/updates.py
@@ -54,6 +54,7 @@ class Updates:
         self.updating_dict = {}
         #debug, ignore me
         self.debug = 0
+        self.obsoletes = {}
 
     def _delFromDict(self, dict_, keys, value):
         for key in keys:
diff --git a/shell.py b/shell.py
index 4c490e8..97bd963 100644
--- a/shell.py
+++ b/shell.py
@@ -114,7 +114,7 @@ class YumShell(cmd.Cmd):
         msg = """
     Shell specific arguments:
       config - set config options
-      repository (or repo) - enable/disable repositories
+      repository (or repo) - enable/disable/list repositories
       transaction (or ts) - list, reset or run the transaction set
       run - run the transaction set
       exit or quit - exit the shell
@@ -131,7 +131,7 @@ class YumShell(cmd.Cmd):
         elif arg in ['repo', 'repository']:
             msg = """
     %s arg [option]
-      list: lists repositories and their status
+      list: lists repositories and their status. option = [all] name/id glob
       enable: enable repositories. option = repository id
       disable: disable repositories. option = repository id
     """ % arg
@@ -337,11 +337,13 @@ class YumShell(cmd.Cmd):
                 if e.errno == 32:
                     self.logger.critical('\n\nExiting on Broken Pipe')
             else:
-                if returnval != 0:
-                    self.verbose_logger.info('Transaction did not run.')
+                if returnval not in [0,1]:
+                    self.verbose_logger.info('Transaction encountered a serious error.')
                 else:
+                    if returnval == 1:
+                        self.verbose_logger.info('There were non-fatal errors in the transaction')
                     self.verbose_logger.log(logginglevels.INFO_2,
                         'Finished Transaction')
-                    self.base.closeRpmDB()
+                self.base.closeRpmDB()
 
 
